"""Places bricks based on data generated by the compass
    Inputs:
        comp_centre (3d pnt): Centre point of the compass
        arm_length (list: float): Length of the arm of the compass for the selected brick
        inclination (list: float): Vertical angle in degrees of the arm for all the bricks
        azimuth (list: float): Horizontal angle in degrees of the arm for all the bricks
        local_inclination (list: float): Vertical local angle in degrees for all the bricks. If it is the same as the arm of the compass, the angle is 0.
        local_azimuth (list: float): Horizontal local angle in degrees for all the bricks. If it is the same as the arm of the compass, the angle is 0.
        brick_dimensions (list: str): A list of strings which hold the dimensions of the brick types
        create_copy (bool): If set to True create a copy
    Output:
        all_bricks: All bricks created by the script"""

__author__ = "Jeroen de Bruijn J.P.deBruijn@student.tudelft.nl"
__version__ = "2018.10.11"



# Check if a copy needs to be created
if create_copy == True:
    
    
    
    ##### INPUT
    
    # Import
    import Rhino.Geometry as rg
    import math as m
    
    
    
    ##### FUNCTIONS
    
    def placeBrick(input_point, input_radius, input_inclination, input_azimuth, input_local_incline, input_local_azim, input_size):
        # Convert from degrees to radians
        rad_incl = m.radians(input_inclination)
        rad_azi = m.radians(input_azimuth)
        rad_local_incl = m.radians(input_local_incline)
        rad_local_azi = m.radians(input_local_azim)
        
        # Calculate arm end X coordinate
        x = input_point.X + ( input_radius * m.sin(rad_incl) * m.cos(rad_azi) )
        # Calculate arm end Y coordinate
        y = input_point.Y + ( input_radius * m.sin(rad_incl) * m.sin(rad_azi) )
        # Calculate arm end Z coordinate
        z = input_point.Z + ( input_radius * m.cos(rad_incl) )
        # Create point
        brick_centre = rg.Point3d(x, y, z)
        
        # Calculate distance from brick centre to compass centre
        dist = [input_point.X - x, input_point.Y - y, input_point.Z - z]
        # Normalize it to a unit vector
        norm = m.sqrt( m.pow(dist[0],2) + m.pow(dist[1],2) + m.pow(dist[2],2) )
        # Create vector
        compass_arm_vector = rg.Vector3d( dist[0] / norm, dist[1] / norm, dist[2] / norm )
        
        # Caulate the cross product between a vertical vector and the arm of the compass
        cross_pr = rg.Vector3d.CrossProduct(rg.Vector3d(0,0,1), compass_arm_vector)
        # Create plane on the centre of the brick
        temp_plane = rg.Plane(brick_centre, cross_pr)
        # Create interval
        interv = rg.Interval(-1, 1)
        # Create temp box to get perpendicular vectors
        temp_box = rg.Box( temp_plane, interv, interv, interv )
        
        # Use the 3the vector of the box and the compass arm vector to align the new plane properly
        br_plane = rg.Plane(brick_centre, temp_box.Plane[3], compass_arm_vector)
        
        # Amount of variables
        amount_of_vars = 3
        # Split the input string which holds the brick dimension
        br_dim = input_size.split()
        # Create variables and divide the size by 2 so an interval can be created with - and + this value
        br_x = int(br_dim[0]) / 2
        br_y = int(br_dim[1]) / 2
        br_z = int(br_dim[2]) / 2
        # Create brick 
        brk = rg.Box( br_plane, rg.Interval(-br_x, br_x), rg.Interval(-br_y, br_y), rg.Interval(-br_z, br_z) )
        
        # Get rotation value to rotate the brick a given angle in radians
        # Use the horizontal axis of the brick (with brk.Plane[1]) as a rotation axis
        rotation = rg.Transform.Rotation( rad_local_incl, brk.Plane[1],  brk.Center )
        # Rotate the brick
        brk.Transform(rotation)
        
        # Get rotation value to rotate the brick a given angle in radians
        # Use the vertical axis of the brick (with brk.Plane[3]) as a rotation axis
        rotation = rg.Transform.Rotation( rad_local_azi, brk.Plane[3],  brk.Center )
        # Rotate the brick
        brk.Transform(rotation)
        
        # Return value
        return brk
    
    
    
    ##### CODE
    
    # Empty list
    list_of_bricks = []
    
    # Loop trough input lists
    for i in range(len(arm_length)):
        # Call function to create a brick
        br = placeBrick(comp_centre, arm_length[i], inclination[i], azimuth[i], local_inclination[i], local_azimuth[i], brick_dimensions[i])
        # Add brick to the list
        list_of_bricks.append(br)
    
    
    
    ##### OUTPUT
    
    all_bricks = list_of_bricks